
<p>SCARLET is a system for managing the internet connections for the
clients of a small ISP, the computers of a school, the staff of an
office, etc. It is made up of a linux box that is configured to be
gateway/router for a LAN of client computers. The configuration of
this gateway box is done by some network scripts, and it can be
managed through a web application that is installed in it (e.g. for
changing the network settings, rebooting it, etc.). The administrator
of the internet (of the gateway) can also use this web application to
allow or disallow the clients to access the internet, even if they are
physically connected (wired). It can also use it to limit the
bandwidth of the LAN behind the gateway. Besides these, the web
application in the gateway can help the internet administrator to keep
track of the clients: a list of them, contact details for each client
(phone, email, address, etc.), the status of the client (connected or
not, how many computers connected, payed or not, etc.). It also keeps
a log (history) of the important events that happen in the router,
e.g. allowing/denying access to somebody, rebooting the system,
changing settings, etc.</p>

<p>An alternative to using a system like this would be to physically
disconnect the clients from the network, e.g. by unpluging their
network cable from the hub/switch. The advantages of the soft
(programatical) way over the hard (physical) one are:</p>

<ul>
  <li>It is more easy and convenient to do it from your computer,
      rather then finding out the right cable to be unplugged and
      unpluging it.</li>

  <li>Sometimes the cable can be plugged into a hub to which you don't
      have access (or don't have access easily). Disconnecting the
      whole hub would mean to disconnect other clients as well, which
      should not be disconnected.</li>

  <li>If the clients use wireless connections to access the internet,
      they are physically connected to your antenna all the time and
      it is almost impossible to disconnect them physically. The
      alternative in this case would be to allow or deny their MACs in
      the Access Point, which may not be so convenient, because it may
      not be so easy to find out to whom belongs a certain MAC
      address.</li>

  <li>The soft way (doing it through an application) allows for
      automatic connection/disconnection of the clients, depending on
      certain conditions. E.g. if a time limit is expired, the
      connection of the client can be interrupted automatically.</li>

  <li>It makes easy the bandwidth limitation of the LAN, which in
      general is not so easy to be done.</li>

  <li>The application offers other features as well, e.g. a list of
      all the clients, their contacts, their status (how many
      computers they have connected), a log (history) of
      connection/disconnection events, etc.</li>
</ul>

<h2>How It Works</h2>

<p>When a client tries to access the Internet, he gets a blocking
screen for any page that he tries to open. Here he is prompted for a
username and password, which are required in order to get internet
access. The username and password can be obtained by contacting the
ISP, using the contact info provided in the page.</p>

<p>Giving a valid username and password, the client is registered and
gets internet access (the gateway registers the MAC of this computer
and allows it to access the internet). From the time of registration
untill the time of expiration, the client (the registered computer)
can use the internet normally.</p>

<p>The administrator(s) of the router/gateway can access and manage it
through a web interface, using edit.php. They are authenticated with
a username and password. After logging in successfully, the admin will have access to several interfaces (tabs). These interfaces are:</p>

<ul>
  <li>Clients -- used to manage the clients that get network access
  through the gateway.</li>

  <li>Settings -- used to modify the settings/options of the gateway
  itself.</li>

  <li>Misc -- several administrative tasks like backup/restore,
  update/upgrade, etc.</li>

  <li>Logs -- records of several important events in the system, like
  adding a client, changing settings, etc.</li>
</ul>


<h2>Demo</h2>

<p>To get a better idea of how it looks like and how it works, try the
demo application. There is the <a href="demo/" target="_blank"> client
interface</a>, where the clients get registered, and the <a
href="demo/admin.php" target="_blank">admin inteface</a>, which is
used by the admin(s) to manage the clients, network settings, view the
logs, etc. For the client interface try these (username, password):
(test1, test1), (test2, test2), (test3, test3). For the admin
interface login with (admin1, admin1) and (admin2, admin2)</p>


<h2>Download</h2>

<p><a
href="http://sourceforge.net/project/showfiles.php?group_id=164743">Download
release files</a> or get the latest version from Subversion with a
command like this: 
<pre>$ svn checkout https://svn.sourceforge.net/svnroot/netaccess/scarlet/trunk scarlet</pre>
</p>

<h2>Copying</h2>

<include src="{{./}}copying.html" />
